Subject: bug#69717: Warnings about prototype mismatch from makeinfo

From: Tomas Volf <[email-masked]>
Date: Mon, 11 Mar 2024 00:07:16 +0100

Hello,

when I take an example .texi file from Texinfo's manual:

\input texinfo
@settitle Sample Manual 1.0

@copying
This is a short example of a complete Texinfo file.

Copyright @copyright{} 2016 Free Software Foundation, Inc.
@end copying

@titlepage
@title Sample Title
@page
@vskip 0pt plus 1filll
@insertcopying
@end titlepage

@contents

@node Top
@top GNU Sample

This manual is for GNU Sample

@menu
* First Chapter::    The first chapter is the
                      only chapter in this sample.
* Index::            Complete index.
@end menu

@node First Chapter
@chapter First Chapter

@cindex chapter, first
This is the first chapter.
@cindex index entry, another

Here is a numbered list.

@enumerate
@item
This is the first item.

@item
This is the second item.
@end enumerate

@node First Section
@section First Section

First section of first chapter.

@node Second Section
@section Second Section

Second section of first chapter.

@node Index
@unnumbered Index

@printindex cp

@bye

And try to produce .info file from it, I get several warning about subroutines
being redefined with mismatching prototypes:

/tmp $ guix shell -C gcc-toolchain texinfo -- makeinfo xxx.texi
Prototype mismatch: sub Texinfo::Convert::Paragraph::new ($;@) vs ($;$) at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 53, <$fh> line 8.
Subroutine new redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 40, <$fh> line 8.
Subroutine end_line_count redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 76, <$fh> line 8.
Subroutine end_line redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 82, <$fh> line 8.
Subroutine _end_line redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 90, <$fh> line 8.
Subroutine get_pending redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 105, <$fh> line 8.
Prototype mismatch: sub Texinfo::Convert::Paragraph::add_pending_word ($;@) vs ($;$) at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 123, <$fh> line 8.
Subroutine add_pending_word redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 118, <$fh> line 8.
Subroutine end redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 163, <$fh> line 8.
Prototype mismatch: sub Texinfo::Convert::Paragraph::add_next ($$;@) vs ($;$$) at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 190, <$fh> line 8.
Subroutine add_next redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 184, <$fh> line 8.
Subroutine remove_end_sentence redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 251, <$fh> line 8.
Prototype mismatch: sub Texinfo::Convert::Paragraph::add_end_sentence ($$) vs ($;$) at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 260, <$fh> line 8.
Subroutine add_end_sentence redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 256, <$fh> line 8.
Subroutine allow_end_sentence redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 263, <$fh> line 8.
Prototype mismatch: sub Texinfo::Convert::Paragraph::set_space_protection ($$;@) vs ($$;$$$$) at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 291, <$fh> line 8.
Subroutine set_space_protection redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 270, <$fh> line 8.
Subroutine add_text redefined at /gnu/store/4zkk85pkwdafpf3qd6q47xq0fw08kv30-texinfo-7.0.3/share/texinfo/Texinfo/Convert/ParagraphNonXS.pm line 298, <$fh> line 8.

Am I doing something wrong or is this expected?

Have a nice day,
Tomas Volf

--
There are only two hard things in Computer Science:
cache invalidation, naming things and off-by-one errors.